/********************************************************
Copyright (c) <2019> <copyright ErosZy>

"Anti 996" License Version 1.0 (Draft)

Permission is hereby granted to any individual or legal entity
obtaining a copy of this licensed work (including the source code,
documentation and/or related items, hereinafter collectively referred
to as the "licensed work"), free of charge, to deal with the licensed
work for any purpose, including without limitation, the rights to use,
reproduce, modify, prepare derivative works of, distribute, publish
and sublicense the licensed work, subject to the following conditions:

1. The individual or the legal entity must conspicuously display,
without modification, this License and the notice on each redistributed
or derivative copy of the Licensed Work.

2. The individual or the legal entity must strictly comply with all
applicable laws, regulations, rules and standards of the jurisdiction
relating to labor and employment where the individual is physically
located or where the individual was born or naturalized; or where the
legal entity is registered or is operating (whichever is stricter). In
case that the jurisdiction has no such laws, regulations, rules and
standards or its laws, regulations, rules and standards are
unenforceable, the individual or the legal entity are required to
comply with Core International Labor Standards.

3. The individual or the legal entity shall not induce, suggest or force
its employee(s), whether full-time or part-time, or its independent
contractor(s), in any methods, to agree in oral or written form, to
directly or indirectly restrict, weaken or relinquish his or her
rights or remedies under such laws, regulations, rules and standards
relating to labor and employment as mentioned above, no matter whether
such written or oral agreements are enforceable under the laws of the
said jurisdiction, nor shall such individual or the legal entity
limit, in any methods, the rights of its employee(s) or independent
contractor(s) from reporting or complaining to the copyright holder or
relevant authorities monitoring the compliance of the license about
its violation(s) of the said license.

THE LICENSED WORK IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN ANY WAY CONNECTION WITH THE
LICENSED WORK OR THE USE OR OTHER DEALINGS IN THE LICENSED WORK.
*********************************************************/

#ifndef CODEC_DATA_TAG_TEST_H
#define CODEC_DATA_TAG_TEST_H

#include <iostream>
#include <stdint.h>
#include "vassert.h"
#include "stream/buffer.h"
#include "demuxer/data_tag.h"

void test_data_tag() {
  cout << "\033[33m " << "data_tag: \033[0m" << endl;
  uint8_t ptr[] = {
          0x02, 0x00, 0x0a, 0x6f, 0x6e, 0x4d, 0x65, 0x74, 0x61, 0x44, 0x61, 0x74, 0x61, // kString -> onMetaData(10)
          0x08, 0x00, 0x00, 0x00, 0x1a, // kECMAArray -> 26
          0x00, 0x0b, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, // kString -> description
          0x02, 0x00, 0x49, // kString -> 73
          0x50, 0x61, 0x63, 0x6b, 0x65, 0x64, 0x20, 0x62, 0x79, 0x20, 0x42, 0x69, 0x6c, 0x69, 0x62, 0x69, 0x6c, 0x69,
          0x20, 0x58, 0x43, 0x6f, 0x64, 0x65, 0x72, 0x20, 0x28, 0x42, 0x69, 0x6c, 0x69, 0x62, 0x69, 0x6c, 0x69, 0x20,
          0x58, 0x43, 0x6f, 0x64, 0x65, 0x20, 0x57, 0x6f, 0x72, 0x6b, 0x65, 0x72, 0x20, 0x76, 0x34, 0x2e, 0x31, 0x2e,
          0x30, 0x29, 0x28, 0x66, 0x69, 0x78, 0x65, 0x64, 0x5f, 0x67, 0x61, 0x70, 0x3a, 0x46, 0x61, 0x6c, 0x73, 0x65,
          0x29, // Packed by Bilibili XCoder (Bilibili XCode Worker v4.1.0)(fixed_gap:False)
          0x00, 0x0f, 0x6d, 0x65, 0x74, 0x61, 0x64, 0x61, 0x74, 0x61, 0x63, 0x72, 0x65, 0x61, 0x74, 0x6f,
          0x72, // kString -> metadatacreator
          0x02, 0x00, 0x33, // kString -> 51
          0x59, 0x65, 0x74, 0x20, 0x41, 0x6e, 0x6f, 0x74, 0x68, 0x65, 0x72, 0x20, 0x4d, 0x65, 0x74, 0x61, 0x64, 0x61,
          0x74, 0x61, 0x20, 0x49, 0x6e, 0x6a, 0x65, 0x63, 0x74, 0x6f, 0x72, 0x20, 0x66, 0x6f, 0x72, 0x20, 0x46, 0x4c,
          0x56, 0x20, 0x2d, 0x20, 0x56, 0x65, 0x72, 0x73, 0x69, 0x6f, 0x6e, 0x20, 0x31, 0x2e,
          0x39, // Yet Another Metadata Injector for FLV - Version 1.9
          0x00, 0x0c, 0x68, 0x61, 0x73, 0x4b, 0x65, 0x79, 0x66, 0x72, 0x61, 0x6d, 0x65,
          0x73, // kString -> hasKeyframes
          0x01, 0x01, // kBoolean -> true
          0x00, 0x08, 0x68, 0x61, 0x73, 0x56, 0x69, 0x64, 0x65, 0x6f, // kString -> hasVideo
          0x01, 0x01, // kBoolean -> true
          0x00, 0x08, 0x68, 0x61, 0x73, 0x41, 0x75, 0x64, 0x69, 0x6f, // kString -> hasAudio
          0x01, 0x01, // kBoolean -> true
          0x00, 0x0b, 0x68, 0x61, 0x73, 0x4d, 0x65, 0x74, 0x61, 0x64, 0x61, 0x74, 0x61, // kString -> hasMetadata
          0x01, 0x01, // kBoolean -> true
          0x00, 0x0c, 0x63, 0x61, 0x6e, 0x53, 0x65, 0x65, 0x6b, 0x54, 0x6f, 0x45, 0x6e,
          0x64, // kString -> canSeekToEnd
          0x01, 0x01, // kBoolean -> true
          0x00, 0x08, 0x64, 0x75, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, // kString -> duration
          0x00, 0x40, 0x72, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber -> 293.25
          0x00, 0x08, 0x64, 0x61, 0x74, 0x61, 0x73, 0x69, 0x7a, 0x65, // kString -> datasize
          0x00, 0x41, 0x8b, 0x8c, 0x03, 0x88, 0x00, 0x00, 0x00, // kNumber -> 57770097
          0x00, 0x09, 0x76, 0x69, 0x64, 0x65, 0x6f, 0x73, 0x69, 0x7a, 0x65, // kString -> videosize
          0x00, 0x41, 0x89, 0x2f, 0x57, 0x70, 0x00, 0x00, 0x00, // kNumber -> 52816622
          0x00, 0x09, 0x66, 0x72, 0x61, 0x6d, 0x65, 0x72, 0x61, 0x74, 0x65, // kString -> framerate
          0x00, 0x40, 0x38, 0x02, 0x9e, 0x71, 0xec, 0x5b, 0xaa, // kNumber -> 24.010230179028135
          0x00, 0x0d, 0x76, 0x69, 0x64, 0x65, 0x6f, 0x64, 0x61, 0x74, 0x61, 0x72, 0x61, 0x74,
          0x65, // kString -> videodatarate
          0x00, 0x40, 0x95, 0xf4, 0x1d, 0xc3, 0x54, 0x06, 0x1c, // kNumber -> 1405.02906543052
          0x00, 0x0c, 0x76, 0x69, 0x64, 0x65, 0x6f, 0x63, 0x6f, 0x64, 0x65, 0x63, 0x69,
          0x64, // kString -> videocodecid
          0x00, 0x40, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber 7
          0x00, 0x05, 0x77, 0x69, 0x64, 0x74, 0x68, // kString -> width
          0x00, 0x40, 0x94, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber 1280
          0x00, 0x06, 0x68, 0x65, 0x69, 0x67, 0x68, 0x74, // kString -> height
          0x00, 0x40, 0x86, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber -> 720
          0x00, 0x09, 0x61, 0x75, 0x64, 0x69, 0x6f, 0x73, 0x69, 0x7a, 0x65, // kString -> audiosize
          0x00, 0x41, 0x52, 0x94, 0x2d, 0xc0, 0x00, 0x00, 0x00, // kNumber -> 4870327
          0x00, 0x0d, 0x61, 0x75, 0x64, 0x69, 0x6f, 0x64, 0x61, 0x74, 0x61, 0x72, 0x61, 0x74,
          0x65, // kString -> audiodatarate
          0x00, 0x40, 0x5f, 0x6e, 0x61, 0x1a, 0x4a, 0x43, 0xe8, // kNumber -> 125.72467667820422
          0x00, 0x0c, 0x61, 0x75, 0x64, 0x69, 0x6f, 0x63, 0x6f, 0x64, 0x65, 0x63, 0x69,
          0x64, // kString -> audiocodecid
          0x00, 0x40, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber -> 10
          0x00, 0x0f, 0x61, 0x75, 0x64, 0x69, 0x6f, 0x73, 0x61, 0x6d, 0x70, 0x6c, 0x65, 0x72, 0x61, 0x74,
          0x65, // kString -> audiosamplerate
          0x00, 0x40, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber -> 3
          0x00, 0x0f, 0x61, 0x75, 0x64, 0x69, 0x6f, 0x73, 0x61, 0x6d, 0x70, 0x6c, 0x65, 0x73, 0x69, 0x7a,
          0x65, // kString -> audiosamplesize
          0x00, 0x3f, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber -> 1
          0x00, 0x06, 0x73, 0x74, 0x65, 0x72, 0x65, 0x6f, // kString -> stereo
          0x01, 0x01, // kBoolean -> true
          0x00, 0x08, 0x66, 0x69, 0x6c, 0x65, 0x73, 0x69, 0x7a, 0x65, // kString -> filesize
          0x00, 0x41, 0x8b, 0x8c, 0x47, 0x98, 0x00, 0x00, 0x00, // kNumber -> 57772275
          0x00, 0x0d, 0x6c, 0x61, 0x73, 0x74, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d,
          0x70, // kString -> lasttimestamp
          0x00, 0x40, 0x72, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber -> 293.25
          0x00, 0x15, 0x6c, 0x61, 0x73, 0x74, 0x6b, 0x65, 0x79, 0x66, 0x72, 0x61, 0x6d, 0x65, 0x74, 0x69, 0x6d, 0x65,
          0x73, 0x74, 0x61, 0x6d, 0x70, // kString -> lastkeyframetimestamp
          0x00, 0x40, 0x72, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, // kNumber -> 293.25
          0x00, 0x14, 0x6c, 0x61, 0x73, 0x74, 0x6b, 0x65, 0x79, 0x66, 0x72, 0x61, 0x6d, 0x65, 0x6c, 0x6f, 0x63, 0x61,
          0x74,
          0x69, 0x6f, 0x6e, // kString -> lastkeyframelocation
          0x00, 0x41, 0x8b, 0x8c, 0x46, 0xf8, 0x00, 0x00, 0x00, // kNumber -> 57772255
          0x00, 0x09, 0x6b, 0x65, 0x79, 0x66, 0x72, 0x61, 0x6d, 0x65, 0x73, // kString -> keyframes
          0x03, // kObject
          0x00, 0x0d, 0x66, 0x69, 0x6c, 0x65, 0x70, 0x6f, 0x73, 0x69, 0x74, 0x69, 0x6f, 0x6e,
          0x73, // kString -> filepositions
          0x0a, 0x00, 0x00, 0x00, 0x51, // kStrictArray -> 81
          0x00, 0x40, 0xa1, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, // start kStrictArray -> kNumber
          0x00, 0x40, 0xa1, 0xa6, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x32, 0x1a, 0xc0, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x4c, 0x5e, 0x2d, 0x80, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x50, 0xee, 0x34, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x51, 0x96, 0xad, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x53, 0x19, 0xeb, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x54, 0x50, 0x00, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x55, 0x62, 0x52, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x56, 0xb0, 0x4a, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x57, 0xc5, 0x16, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x58, 0x77, 0x90, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x5a, 0xfc, 0xc2, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x5c, 0x1d, 0xfc, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x60, 0x0d, 0xba, 0xa0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x62, 0xb5, 0x2c, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x63, 0x3a, 0x34, 0x60, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x65, 0x69, 0x80, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x66, 0x8f, 0x3b, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x67, 0x1c, 0x6a, 0x60, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x67, 0x6f, 0x82, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x68, 0x5a, 0x18, 0x80, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x68, 0xd6, 0x38, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x69, 0x97, 0x42, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6a, 0x36, 0x4c, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6b, 0x27, 0xaf, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6c, 0x00, 0x3f, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6c, 0x4a, 0x96, 0x80, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6c, 0xf3, 0xe7, 0xe0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6d, 0x32, 0x31, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6d, 0x78, 0x86, 0x80, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6e, 0x45, 0x13, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x6f, 0xa6, 0xda, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x70, 0x6c, 0x96, 0x90, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x70, 0xbb, 0x32, 0xf0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x71, 0x5a, 0x29, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x71, 0xaf, 0x2a, 0x50, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x71, 0xeb, 0xa7, 0xf0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x72, 0x14, 0x4e, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x72, 0x4b, 0xee, 0x80, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x76, 0xc4, 0xf2, 0x90, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x77, 0x8d, 0x31, 0xe0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x78, 0x35, 0x78, 0x50, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x78, 0x9b, 0x73, 0x30, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x79, 0x2b, 0x33, 0x60, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x79, 0xd1, 0xde, 0xe0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7a, 0xb8, 0x8b, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7a, 0xfb, 0x73, 0x30, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7b, 0x45, 0x59, 0x20, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7c, 0x94, 0x5b, 0xe0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7d, 0x05, 0x06, 0x30, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7d, 0xbd, 0x79, 0x10, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7e, 0x53, 0x6e, 0x80, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7e, 0xb9, 0x69, 0xf0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x7e, 0xf7, 0x6b, 0xf0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x80, 0x18, 0xc4, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x80, 0x41, 0xcd, 0x18, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x80, 0x75, 0x68, 0xa8, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x82, 0xc4, 0xad, 0x08, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x82, 0xeb, 0xf0, 0xe8, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x83, 0x92, 0xee, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x83, 0xb6, 0x9f, 0xf0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x84, 0xc5, 0x41, 0xf8, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x85, 0x14, 0x43, 0xf0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x85, 0x5c, 0x60, 0x90, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x85, 0x6d, 0xa7, 0xa8, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x85, 0xae, 0x6c, 0x50, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x85, 0xf0, 0x3b, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x86, 0x39, 0x32, 0x28, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x86, 0x7f, 0x38, 0xf8, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x87, 0x86, 0x35, 0xf0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x87, 0xe1, 0xa0, 0x50, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x88, 0x10, 0xbc, 0xe0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x88, 0x28, 0x0c, 0x50, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x88, 0x55, 0x32, 0x40, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x89, 0x80, 0xaf, 0xc0, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x89, 0xa0, 0xcd, 0x50, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x8a, 0x03, 0x74, 0x18, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x8b, 0x02, 0xc4, 0x68, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x8b, 0x47, 0xe4, 0xe8, 0x00, 0x00, 0x00,
          0x00, 0x41, 0x8b, 0x8c, 0x46, 0xf8, 0x00, 0x00, 0x00, // end kStrictArray -> kNumber
          0x00, 0x05, 0x74, 0x69, 0x6d, 0x65, 0x73, // kString -> times
          0x0a, 0x00, 0x00, 0x00, 0x51, // kStrictArray -> 81
          0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // start kStrictArray -> kNumber
          0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x23, 0xea, 0x7e, 0xf9, 0xdb, 0x22, 0xd1,
          0x00, 0x40, 0x32, 0xaa, 0x7e, 0xf9, 0xdb, 0x22, 0xd1,
          0x00, 0x40, 0x39, 0xea, 0x7e, 0xf9, 0xdb, 0x22, 0xd1,
          0x00, 0x40, 0x3c, 0x4a, 0x7e, 0xf9, 0xdb, 0x22, 0xd1,
          0x00, 0x40, 0x40, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x41, 0x7a, 0x9f, 0xbe, 0x76, 0xc8, 0xb4,
          0x00, 0x40, 0x42, 0x6a, 0x9f, 0xbe, 0x76, 0xc8, 0xb4,
          0x00, 0x40, 0x43, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x43, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x44, 0x7a, 0x9f, 0xbe, 0x76, 0xc8, 0xb4,
          0x00, 0x40, 0x46, 0x2a, 0x9f, 0xbe, 0x76, 0xc8, 0xb4,
          0x00, 0x40, 0x46, 0xe5, 0x3f, 0x7c, 0xed, 0x91, 0x68,
          0x00, 0x40, 0x4b, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x4d, 0x25, 0x3f, 0x7c, 0xed, 0x91, 0x68,
          0x00, 0x40, 0x4e, 0x4a, 0x9f, 0xbe, 0x76, 0xc8, 0xb4,
          0x00, 0x40, 0x51, 0xa2, 0x9f, 0xbe, 0x76, 0xc8, 0xb4,
          0x00, 0x40, 0x52, 0x3a, 0x9f, 0xbe, 0x76, 0xc8, 0xb4,
          0x00, 0x40, 0x52, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x52, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x53, 0xf5, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x54, 0xd5, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x56, 0x4d, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x57, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x58, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x59, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x59, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x5b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x5b, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x5b, 0xa8, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x5c, 0xd2, 0x9f, 0xbe, 0x76, 0xc8, 0xb4,
          0x00, 0x40, 0x5e, 0x0d, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x5f, 0x98, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x60, 0x69, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x60, 0xec, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x61, 0x6a, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x61, 0x9e, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x61, 0xc8, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x62, 0x0d, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x63, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x63, 0x8a, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x63, 0xb9, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x63, 0xf6, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x64, 0x3a, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x64, 0xb2, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x65, 0x82, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x65, 0xac, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x65, 0xce, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x66, 0x9a, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x67, 0x29, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x67, 0x81, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x67, 0xf1, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x68, 0x5d, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x68, 0xa5, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x69, 0x46, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x69, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x69, 0xa8, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x6a, 0xe6, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x6b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x6b, 0xb1, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x6b, 0xdd, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x6c, 0xb9, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x6d, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x6d, 0x51, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x6d, 0x8a, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x6d, 0xf5, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x6e, 0x85, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x6e, 0xbd, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x6e, 0xed, 0x4f, 0xdf, 0x3b, 0x64, 0x5a,
          0x00, 0x40, 0x70, 0x16, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x70, 0x3b, 0x53, 0xf7, 0xce, 0xd9, 0x17,
          0x00, 0x40, 0x70, 0x6a, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x70, 0x84, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x70, 0x9d, 0x53, 0xf7, 0xce, 0xd9, 0x17,
          0x00, 0x40, 0x71, 0x3b, 0x53, 0xf7, 0xce, 0xd9, 0x17,
          0x00, 0x40, 0x71, 0x4b, 0x53, 0xf7, 0xce, 0xd9, 0x17,
          0x00, 0x40, 0x71, 0x72, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x72, 0x12, 0x00, 0x00, 0x00, 0x00, 0x00,
          0x00, 0x40, 0x72, 0x38, 0xa7, 0xef, 0x9d, 0xb2, 0x2d,
          0x00, 0x40, 0x72, 0x54, 0x00, 0x00, 0x00, 0x00, 0x00, // end kStrictArray -> kNumber
          0x00, 0x00, 0x09, // kObjectEnd
          0x00, 0x00, 0x09 // kObjectEnd
  };
  shared_ptr<Buffer> b = make_shared<Buffer>(ptr, 2150);
  DataTag tag;
  DataTagValue value = tag.decode(b, 2150);
  VASSERT(value.buffer->get_length() == 0, "");
  VASSERT(value.objects->size() == 1, "");
  VASSERT(value.objects->at(0).type == 3, "");
  VASSERT(value.objects->at(0).strValue == string("onMetaData"), "");
  VASSERT(value.objects->at(0).next->arrayValue->size() == 26, "");
  
  VASSERT(true, "DataTag pass");
}

#endif //CODEC_DATA_TAG_TEST_H
